<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        
        
        
        <link rel="shortcut icon" href="img/favicon.ico">
        <title>Filtering - PM4Py-mongo Documentation</title>
        <link href="css/bootstrap-custom.min.css" rel="stylesheet">
        <link href="css/font-awesome.min.css" rel="stylesheet">
        <link href="css/base.css" rel="stylesheet">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
        <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
        <!--[if lt IE 9]>
            <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
            <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
        <![endif]-->

        <script src="js/jquery-1.10.2.min.js" defer></script>
        <script src="js/bootstrap-3.0.3.min.js" defer></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
        <script>hljs.initHighlightingOnLoad();</script> 
    </head>

    <body>

        <div class="navbar navbar-default navbar-fixed-top" role="navigation">
            <div class="container">

                <!-- Collapsed navigation -->
                <div class="navbar-header">
                    <!-- Expander button -->
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="sr-only">Toggle navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="index.html">PM4Py-mongo Documentation</a>
                </div>

                <!-- Expanded navigation -->
                <div class="navbar-collapse collapse">
                        <!-- Main navigation -->
                        <ul class="nav navbar-nav">
                            <li >
                                <a href="index.html">Start</a>
                            </li>
                            <li >
                                <a href="import.html">Importing</a>
                            </li>
                            <li class="active">
                                <a href="filter.html">Filtering</a>
                            </li>
                            <li >
                                <a href="dfg.html">DFG Calculation</a>
                            </li>
                        </ul>

                    <ul class="nav navbar-nav navbar-right">
                        <li>
                            <a href="#" data-toggle="modal" data-target="#mkdocs_search_modal">
                                <i class="fa fa-search"></i> Search
                            </a>
                        </li>
                            <li >
                                <a rel="next" href="import.html">
                                    <i class="fa fa-arrow-left"></i> Previous
                                </a>
                            </li>
                            <li >
                                <a rel="prev" href="dfg.html">
                                    Next <i class="fa fa-arrow-right"></i>
                                </a>
                            </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="container">
                <div class="col-md-3"><div class="bs-sidebar hidden-print affix well" role="complementary">
    <ul class="nav bs-sidenav">
        <li class="main active"><a href="#filtering">Filtering</a></li>
        <li class="main "><a href="#event-level">Event Level</a></li>
            <li><a href="#event_attribute_one_of">event_attribute_one_of()</a></li>
            <li><a href="#event_attribute_in_range">event_attribute_in_range()</a></li>
            <li><a href="#event_in_timerange">event_in_timerange()</a></li>
        <li class="main "><a href="#case-level">Case Level</a></li>
            <li><a href="#case_starts_with">case_starts_with()</a></li>
            <li><a href="#case_ends_with">case_ends_with()</a></li>
            <li><a href="#case_performance_in_range">case_performance_in_range()</a></li>
            <li><a href="#case_attribute_one_of">case_attribute_one_of()</a></li>
            <li><a href="#case_in_timerange">case_in_timerange()</a></li>
        <li class="main "><a href="#variants">Variants</a></li>
            <li><a href="#get_variants">get_variants()</a></li>
            <li><a href="#get_frequent_variants">get_frequent_variants()</a></li>
            <li><a href="#variants_1">variants()</a></li>
    </ul>
</div></div>
                <div class="col-md-9" role="main">

<h1 id="filtering">Filtering</h1>
<p>The <em>filter</em> component of the library provides an array of different functions that can be used to filter an event log that is already stored in the database. Filters can be applied on the event or case level. The results of the filtering can be stored inside the database for later reuse.</p>
<h1 id="event-level">Event Level</h1>
<p>The filters in this section act on the event level, meaning that an event will only be included in the filtering result if it matches the filtering condition.</p>
<hr />
<h2 id="event_attribute_one_of"><code>event_attribute_one_of()</code></h2>
<h3 id="description">Description</h3>
<p>Filters the given collection based on the passed attribute. Returns only the events in which the attribute corresponds to one of the given values.</p>
<h3 id="input">Input</h3>
<ul>
<li><code>attribute</code> - String<ul>
<li>The name of the to-be-filtered attribute.</li>
</ul>
</li>
<li><code>values</code> - List<ul>
<li>A list of allowed values that the attribute is allowed to take.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes">Notes</h3>
<p>-</p>
<hr />
<h2 id="event_attribute_in_range"><code>event_attribute_in_range()</code></h2>
<h3 id="description_1">Description</h3>
<p>Filters the given collection based on the passed attribute. Returns only the events in which the attribute is contained in the given range <code>[min,max]</code>. Can be used for all comparable types.</p>
<h3 id="input_1">Input</h3>
<ul>
<li><code>attribute</code> - String<ul>
<li>The name of the to-be-filtered attribute.</li>
</ul>
</li>
<li><code>min</code> - Comparable<ul>
<li>The minimal allowed value (inclusive).</li>
</ul>
</li>
<li><code>max</code> - Comparable<ul>
<li>The maximal allowed value (inclusive).</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_1">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_1">Notes</h3>
<p>To filter based on a timerange, consider the <code>event_in_timerange()</code> filter.</p>
<hr />
<h2 id="event_in_timerange"><code>event_in_timerange()</code></h2>
<h3 id="description_2">Description</h3>
<p>Filters the given collection based on the passed time attribute. Returns only the events in which the time attribute is contained in the given timerange <code>[min,max]</code>.</p>
<h3 id="input_2">Input</h3>
<ul>
<li><code>time</code> - String<ul>
<li>The name of the to-be-filtered time attribute.</li>
</ul>
</li>
<li><code>min</code> - Datetime<ul>
<li>The minimal allowed value (inclusive).</li>
</ul>
</li>
<li><code>max</code> - Datetime<ul>
<li>The maximal allowed value (inclusive).</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_2">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_2">Notes</h3>
<p>-</p>
<h1 id="case-level">Case Level</h1>
<p>The filters in this section act on the case level, meaning that an event will only be included in the filtering result if the whole case that the event is belonging to matches the filtering condition.</p>
<hr />
<h2 id="case_starts_with"><code>case_starts_with()</code></h2>
<h3 id="description_3">Description</h3>
<p>Filters the given collection based on the passed start activity. Returns only the events belonging to cases that start with the specified activity.</p>
<h3 id="input_3">Input</h3>
<ul>
<li><code>start_activity</code> - String<ul>
<li>The name of the considered start activity.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_3">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_3">Notes</h3>
<p>To filter based on the end activity see <code>case_ends_with()</code>.</p>
<hr />
<h2 id="case_ends_with"><code>case_ends_with()</code></h2>
<h3 id="description_4">Description</h3>
<p>Filters the given collection based on the passed end activity. Returns only the events belonging to cases that end with the specified activity.</p>
<h3 id="input_4">Input</h3>
<ul>
<li><code>end_activity</code> - String<ul>
<li>The name of the considered end activity.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_4">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_4">Notes</h3>
<p>To filter based on the start activity see <code>case_starts_with()</code>.</p>
<hr />
<h2 id="case_performance_in_range"><code>case_performance_in_range()</code></h2>
<h3 id="description_5">Description</h3>
<p>Filters the given collection based on the performance of the cases. Returns only the events belonging to cases that have a performance in the given range.</p>
<h3 id="input_5">Input</h3>
<ul>
<li><code>min</code> - Integer<ul>
<li>The shortest allowed performance in seconds.</li>
</ul>
</li>
<li><code>max</code> - Integer<ul>
<li>The longest allowed performance in seconds.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_5">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_5">Notes</h3>
<p><em>Performance</em> in this case means the time that has passed between the occurance of the first event of the case and the last.</p>
<hr />
<h2 id="case_attribute_one_of"><code>case_attribute_one_of()</code></h2>
<h3 id="description_6">Description</h3>
<p>Filters the given collection based on the given attribute. Returns only the events belonging to cases in which at least one event of the case has a matching attribute value.</p>
<h3 id="input_6">Input</h3>
<ul>
<li><code>attribute</code> - String<ul>
<li>The name of the to-be-filtered attribute.</li>
</ul>
</li>
<li><code>values</code> - List<ul>
<li>A list of allowed values that the attribute is allowed to take.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_6">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_6">Notes</h3>
<p>-</p>
<hr />
<h2 id="case_in_timerange"><code>case_in_timerange()</code></h2>
<h3 id="description_7">Description</h3>
<p>Filters the given collection based on a certain time range. Returns only the events belonging to cases that intersect the given time range.</p>
<h3 id="input_7">Input</h3>
<ul>
<li><code>time</code> - String<ul>
<li>Name of the time attribute that should be considered.</li>
</ul>
</li>
<li><code>start</code> - Datetime<ul>
<li>The earlieast point in time that should be considered.</li>
</ul>
</li>
<li><code>end</code> - Datetime<ul>
<li>The latest point in time that should be considered.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection that should be filtered. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the filtered event log should be stored. If the string is empty, the result will not be stored in the database. The default collection value is empty.</li>
</ul>
</li>
</ul>
<h3 id="output_7">Output</h3>
<p>When a result collection is specified, the collection containing the filtered log will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_7">Notes</h3>
<p>The property considered here is the intersection of the given time range.</p>
<h1 id="variants">Variants</h1>
<p>This section explains functions concerned with variants. Variants can be calculated and the log can be filtered based on certain variants.</p>
<hr />
<h2 id="get_variants"><code>get_variants()</code></h2>
<h3 id="description_8">Description</h3>
<p><strong>! Not a Filter !</strong></p>
<p>This function can be used to obtain all variants that are contained in the log. Additionally the frequencies of all variants are calculated.</p>
<h3 id="input_8">Input</h3>
<ul>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>include_cases</code> <em>(optional)</em> - Bool<ul>
<li>A bool indicating wether or not the output should contain a list of all cases that belong to a variant for each variant.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection of which the variants should be calculated. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the obtained variants will be stored. If the string is empty, the result will not be stored in the database. The default collection value is <code>variants</code>.</li>
</ul>
</li>
</ul>
<h3 id="output_8">Output</h3>
<p>When a result collection is specified, the collection containing the variants will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<p>The output collection contains a document for each variant. This document contains the <code>frequency</code> of the variant and if specified also a list of case identifiers <code>cases</code> which are following the variant. </p>
<h3 id="notes_8">Notes</h3>
<p>-</p>
<hr />
<h2 id="get_frequent_variants"><code>get_frequent_variants()</code></h2>
<h3 id="description_9">Description</h3>
<p><strong>! Not a Filter !</strong></p>
<p>This function can be used to obtain all variants that are contained in the log which have a frequency with at least the specified threshhold.</p>
<h3 id="input_9">Input</h3>
<ul>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>threshold</code> - Numerical<ul>
<li>The threshold that is used to determine which variants are "frequent".</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection of which the frequent variants should be calculated. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the obtained variants will be stored. If the string is empty, the result will not be stored in the database. The default collection value is <code>frequentVariants</code>.</li>
</ul>
</li>
</ul>
<h3 id="output_9">Output</h3>
<p>When a result collection is specified, the collection containing the variants will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<p>The output collection contains a document for each variant. This document contains the <code>frequency</code> of the variant and if specified also a list of case identifiers <code>cases</code> which are following the variant. </p>
<h3 id="notes_9">Notes</h3>
<p>This can be used indipendently from the <code>get_variants()</code> function.</p>
<hr />
<h2 id="variants_1"><code>variants()</code></h2>
<h3 id="description_10">Description</h3>
<p>This function filters the collection based on the given variants. Only events belonging to cases that follow one of the specified variants are returned.</p>
<h3 id="input_10">Input</h3>
<ul>
<li><code>values</code> - List<ul>
<li>A list of variants. The variants themselves are represented as an ordered list of activities.</li>
</ul>
</li>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>input_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection of which the variants should be calculated. The default collection is <code>eventData</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the obtained variants will be stored. If the string is empty, the result will not be stored in the database. The default collection value is <code>variants</code>.</li>
</ul>
</li>
</ul>
<h3 id="output_10">Output</h3>
<p>When a result collection is specified, the collection containing the variants will be returned. Else, the result of the filtering operation is directly returned as a cursor. This can be treated as an iteratable or be transformed into a list.</p>
<h3 id="notes_10">Notes</h3>
<p>Due to a technical limitation, this filter currently only supports variants whichs string representation (event1-&gt;event2-&gt;...-&gt;eventN) is smaller than 1024 Bytes. If a variant is longer than that, it will be truncated to a fitting size which might alter the results.</p></div>
        </div>

        <footer class="col-md-12">
            <hr>
            <p>Documentation built with <a href="https://www.mkdocs.org/">MkDocs</a>.</p>
        </footer>
        <script>
            var base_url = ".",
                shortcuts = {"help": 191, "next": 78, "previous": 80, "search": 83};
        </script>
        <script src="js/base.js" defer></script>
        <script src="search/main.js" defer></script>

        <div class="modal" id="mkdocs_search_modal" tabindex="-1" role="dialog" aria-labelledby="Search Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Search</h4>
            </div>
            <div class="modal-body">
                <p>
                    From here you can search these documents. Enter
                    your search terms below.
                </p>
                <form role="form">
                    <div class="form-group">
                        <input type="text" class="form-control" placeholder="Search..." id="mkdocs-search-query" title="Type search term here">
                    </div>
                </form>
                <div id="mkdocs-search-results"></div>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div><div class="modal" id="mkdocs_keyboard_modal" tabindex="-1" role="dialog" aria-labelledby="Keyboard Shortcuts Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Keyboard Shortcuts</h4>
            </div>
            <div class="modal-body">
              <table class="table">
                <thead>
                  <tr>
                    <th style="width: 20%;">Keys</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td class="help shortcut"><kbd>?</kbd></td>
                    <td>Open this help</td>
                  </tr>
                  <tr>
                    <td class="next shortcut"><kbd>n</kbd></td>
                    <td>Next page</td>
                  </tr>
                  <tr>
                    <td class="prev shortcut"><kbd>p</kbd></td>
                    <td>Previous page</td>
                  </tr>
                  <tr>
                    <td class="search shortcut"><kbd>s</kbd></td>
                    <td>Search</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div>

    </body>
</html>
